

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.8. highlight_full &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.9. highlight_html" href="highlight_html.html" />
    <link rel="prev" title="7.15.7. geo_in_rectangle" href="geo_in_rectangle.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/highlight_full.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="highlight_html.html" title="7.15.9. highlight_html"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="geo_in_rectangle.html" title="7.15.7. geo_in_rectangle"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="highlight-full">
<h1><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code><a class="headerlink" href="#highlight-full" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="versionadded">
<p><span class="versionmodified added">バージョン 4.0.5 で追加.</span></p>
</div>
<div class="section" id="summary">
<h2><span class="section-number">7.15.8.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> は対象テキストをタグ付けします。検索文字列をハイライトさせるために利用することができます。HTMLエスケープの有無、ノーマライザー名を指定することができ、キーワードごとにタグを変更することができます。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.8.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> には必須引数と省略可能引数とがあります:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>highlight_full(column, normalizer_name, use_html_escape,
               keyword1, open_tag1, close_tag1,
               ...
               [keywordN, open_tagN, close_tagN])
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.8.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Entries TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Entries body COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms document_index COLUMN_INDEX|WITH_POSITION Entries body
# [[0, 1337566253.89858, 0.000355720520019531], true]
load --table Entries
[
{&quot;body&quot;: &quot;Mroonga is a ＭｙＳＱＬ storage engine based on Groonga. &lt;b&gt;Rroonga&lt;/b&gt; is a Ruby binding of Groonga.&quot;}
]
# [[0, 1337566253.89858, 0.000355720520019531], 1]
</pre></div>
</div>
<p>10.0.6より前のバージョンでは、<code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> は <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドの <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> 内でのみ指定できますが、 10.0.6以降は <a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a> コマンドの <code class="docutils literal notranslate"><span class="pre">--output_columns</span></code> 内でも使用できます。</p>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> を使うには <a class="reference internal" href="../command/command_version.html"><span class="doc">コマンドバージョン</span></a> 2以降を使う必要があります。</p>
<p>以下の例はHTMLエスケープを使用し、ノーマライザーに <code class="docutils literal notranslate"><span class="pre">NormalizerAuto</span></code> を指定しています。この例では キーワード <code class="docutils literal notranslate"><span class="pre">groonga</span></code> に <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword1&quot;&gt;</span></code>  と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> のタグを指定し、キーワード <code class="docutils literal notranslate"><span class="pre">mysql</span></code> に <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword2&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> のタグを指定しています。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns &#39;highlight_full(body, &quot;NormalizerAuto&quot;, true, &quot;Groonga&quot;, &quot;&lt;span class=\\&quot;keyword1\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;, &quot;mysql&quot;, &quot;&lt;span class=\\&quot;keyword2\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;)&#39; --command_version 2
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_full&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;Mroonga is a &lt;span class=\&quot;keyword2\&quot;&gt;ＭｙＳＱＬ&lt;/span&gt; storage engine based on &lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt;. &amp;lt;b&amp;gt;Rroonga&amp;lt;/b&amp;gt; is a Ruby binding of &lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt;.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>キーワードとテキストは <code class="docutils literal notranslate"><span class="pre">NormalizerAuto</span></code> ノーマライザーで正規化されてタグ付けのためにスキャンされます。</p>
<p><code class="docutils literal notranslate"><span class="pre">--query</span> <span class="pre">&quot;groonga</span> <span class="pre">mysql&quot;</span></code> は最初のレコードにマッチします。 <code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> は、テキスト中に含まれるキーワード <code class="docutils literal notranslate"><span class="pre">groonga</span></code> を <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword1&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> で囲み、 キーワード <code class="docutils literal notranslate"><span class="pre">mysql</span></code> を <code class="docutils literal notranslate"><span class="pre">&lt;span</span> <span class="pre">class=&quot;keyword2&quot;&gt;</span></code> と <code class="docutils literal notranslate"><span class="pre">&lt;/span&gt;</span></code> で囲みます。</p>
<p><code class="docutils literal notranslate"><span class="pre">&lt;</span></code> や <code class="docutils literal notranslate"><span class="pre">&gt;</span></code> などの特殊文字は &amp;lt; や &amp;gt; にエスケープされています。</p>
<p>カラムの代わりに文字列リテラルを指定することもできます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Entries --output_columns &#39;highlight_full(&quot;Groonga is very fast fulltext search engine.&quot;, &quot;NormalizerAuto&quot;, true, &quot;Groonga&quot;, &quot;&lt;span class=\\&quot;keyword1\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;, &quot;mysql&quot;, &quot;&lt;span class=\\&quot;keyword2\\&quot;&gt;&quot;, &quot;&lt;/span&gt;&quot;)&#39; --command_version 2 --match_columns body --query &quot;groonga&quot;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;highlight_full&quot;,
#           null
#         ]
#       ],
#       [
#         &quot;&lt;span class=\&quot;keyword1\&quot;&gt;Groonga&lt;/span&gt; is very fast fulltext search engine.&quot;
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.8.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>必須引数は3つあります。 <code class="docutils literal notranslate"><span class="pre">column</span></code> と <code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code> と <code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code> です。省略可能引数は3つ以上あります。 <code class="docutils literal notranslate"><span class="pre">keywordN</span></code> と <code class="docutils literal notranslate"><span class="pre">open_tagN</span></code> と <code class="docutils literal notranslate"><span class="pre">end_tagN</span></code> です。</p>
<div class="section" id="column">
<h3><span class="section-number">7.15.8.4.1. </span><code class="docutils literal notranslate"><span class="pre">column</span></code><a class="headerlink" href="#column" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>テーブルのカラムを指定します。</p>
</div>
<div class="section" id="normalizer-name">
<h3><span class="section-number">7.15.8.4.2. </span><code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code><a class="headerlink" href="#normalizer-name" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>ノーマライザー名を指定します。</p>
</div>
<div class="section" id="use-html-escape">
<h3><span class="section-number">7.15.8.4.3. </span><code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code><a class="headerlink" href="#use-html-escape" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>HTMLエスケープの有無を指定します。 <code class="docutils literal notranslate"><span class="pre">true</span></code> を指定すればHTMLエスケープされます。 <code class="docutils literal notranslate"><span class="pre">false</span></code> を指定すればHTMLエスケープされません。</p>
</div>
<div class="section" id="keywordn">
<h3><span class="section-number">7.15.8.4.4. </span><code class="docutils literal notranslate"><span class="pre">keywordN</span></code><a class="headerlink" href="#keywordn" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>タグ付けするキーワードを指定します。3つの引数ごとに複数のキーワードを指定することができます。</p>
</div>
<div class="section" id="open-tagn">
<h3><span class="section-number">7.15.8.4.5. </span><code class="docutils literal notranslate"><span class="pre">open_tagN</span></code><a class="headerlink" href="#open-tagn" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>開始タグを指定します。3つの引数ごとに複数の開始タグを指定することができます。</p>
</div>
<div class="section" id="close-tagn">
<h3><span class="section-number">7.15.8.4.6. </span><code class="docutils literal notranslate"><span class="pre">close_tagN</span></code><a class="headerlink" href="#close-tagn" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>終了タグを指定します。3つの引数ごとに複数の終了タグを指定することができます。</p>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.8.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> はタグ付の文字列もしくは null を返します。<code class="docutils literal notranslate"><span class="pre">highlight_full</span></code> は該当するキーワードがない場合に null を返します。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.8.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
<li><p><a class="reference internal" href="../commands/logical_select.html"><span class="doc">logical_select</span></a></p></li>
<li><p><a class="reference internal" href="highlight_html.html"><span class="doc">highlight_html</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.8. <code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.8.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.8.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.8.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.8.4. 引数</a><ul>
<li><a class="reference internal" href="#column">7.15.8.4.1. <code class="docutils literal notranslate"><span class="pre">column</span></code></a></li>
<li><a class="reference internal" href="#normalizer-name">7.15.8.4.2. <code class="docutils literal notranslate"><span class="pre">normalizer_name</span></code></a></li>
<li><a class="reference internal" href="#use-html-escape">7.15.8.4.3. <code class="docutils literal notranslate"><span class="pre">use_html_escape</span></code></a></li>
<li><a class="reference internal" href="#keywordn">7.15.8.4.4. <code class="docutils literal notranslate"><span class="pre">keywordN</span></code></a></li>
<li><a class="reference internal" href="#open-tagn">7.15.8.4.5. <code class="docutils literal notranslate"><span class="pre">open_tagN</span></code></a></li>
<li><a class="reference internal" href="#close-tagn">7.15.8.4.6. <code class="docutils literal notranslate"><span class="pre">close_tagN</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.8.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.15.8.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="geo_in_rectangle.html"
                        title="前の章へ"><span class="section-number">7.15.7. </span>geo_in_rectangle</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="highlight_html.html"
                        title="次の章へ"><span class="section-number">7.15.9. </span><code class="docutils literal notranslate"><span class="pre">highlight_html</span></code></a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="highlight_html.html" title="7.15.9. highlight_html"
             >次へ</a> |</li>
        <li class="right" >
          <a href="geo_in_rectangle.html" title="7.15.7. geo_in_rectangle"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.8. </span><code class="docutils literal notranslate"><span class="pre">highlight_full</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>